#include "wpilib.h"
#include "Autonomoose.h"
#include "IOMap.h"
#include "Drive.h"
#include "stdio.h"

#define VISIONTRACKING

const float kTimeForShoot = 6.0;


	Autonomoose::Autonomoose(Drive *drive, Intake *intake, Bucket *bucket, Gear *gear, Shooter *shooter, FuelSystem *fuelSystem):
	Mode(kAutoNothing),
	_currentStep(1),
	_timer(),
	BoilerStep(1)
	{
		_drive = drive;
		_intake = intake;
		_bucket = bucket;
		_gear = gear;
		_shooter = shooter;
		_fuelSystem = fuelSystem;
		_timer.Start();
	}

	void Autonomoose::Set_Auto_Mode(AutoMode automode)
	{
		Mode = automode;
		_currentStep = 1;
	}
	void Autonomoose::AutoDashboardSend(){
			char buffer[256] = "";
			char key[32];

			sprintf(&buffer[strlen(buffer)],",%d", kAutoNothing);
			sprintf(key,"thunderdashboard_auto_%d", kAutoNothing);
			SmartDashboard::PutString(key, "Does nothing....Duh");

			sprintf(&buffer[strlen(buffer)],",%d",kCrossBaseLine);
			sprintf(key,"thunderdashboard_auto_%d", kCrossBaseLine);
			SmartDashboard::PutString(key, "Crosses base line");

			sprintf(&buffer[strlen(buffer)],",%d",kHighBoilerRed);
			sprintf(key,"thunderdashboard_auto_%d", kHighBoilerRed);
			SmartDashboard::PutString(key, "Shoots in high goal on red side of field");

			sprintf(&buffer[strlen(buffer)],",%d",kHightBoilerBlue);
			sprintf(key,"thunderdashboard_auto_%d",kHightBoilerBlue);
			SmartDashboard::PutString(key, "Shoots in high goal on blue side of field");


			sprintf(&buffer[strlen(buffer)],",%d", kCenterGear);
			sprintf(key,"thunderdashboard_auto_%d", kCenterGear);
			SmartDashboard::PutString(key, "Places gear on center of the airship");


			sprintf(&buffer[strlen(buffer)],",%d", kHighBoilerBaselineBlue);
			sprintf(key,"thunderdashboard_auto_%d", kHighBoilerBaselineBlue);
			SmartDashboard::PutString(key, "Shoots in high goal on blue side of field and crosses the base line");


			sprintf(&buffer[strlen(buffer)],",%d",kHighBoilerBaselineRed);
			sprintf(key,"thunderdashboard_auto_%d", kHighBoilerBaselineRed);
			SmartDashboard::PutString(key, "Shoots in high goal on red side of field and crosses the base line");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearLeftBlue);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearLeftBlue);
			SmartDashboard::PutString(key, "Scores gear on the left side of the airship on the blue side");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearRightBlue);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearRightBlue);
			SmartDashboard::PutString(key, "Scores gear on the right side of the airship on the blue side");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearLeftRed);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearLeftRed);
			SmartDashboard::PutString(key, "Scores gear on the left side of the airship on the red side");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearRightRed);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearRightRed);
			SmartDashboard::PutString(key, "Scores gear on the right side of the airship on the red side");

			sprintf(&buffer[strlen(buffer)],",%d",kGearBoilerBlue);
			sprintf(key,"thunderdashboard_auto_%d", kGearBoilerBlue);
			SmartDashboard::PutString(key, "Scores gear and then boiler on the blue side");

			sprintf(&buffer[strlen(buffer)],",%d",kGearBoilerRed);
			sprintf(key,"thunderdashboard_auto_%d", kGearBoilerRed);
			SmartDashboard::PutString(key, "Scores gear and then boiler on the red side");

			sprintf(&buffer[strlen(buffer)],",%d",kOtherHopperBaselineBlue);
			sprintf(key,"thunderdashboard_auto_%d", kOtherHopperBaselineBlue);
			SmartDashboard::PutString(key, "Shoots balls at a low speed into other robot and crosses baseline on blue half");

			sprintf(&buffer[strlen(buffer)],",%d",kOtherHopperBaselineRed);
			sprintf(key,"thunderdashboard_auto_%d", kOtherHopperBaselineRed);
			SmartDashboard::PutString(key, "Shoots balls at a low speed into other robot and crosses baseline on red half");

			sprintf(&buffer[strlen(buffer)],",%d",kHopperBoilerRed);
			sprintf(key,"thunderdashboard_auto_%d", kHopperBoilerRed);
			SmartDashboard::PutString(key, "Shoots from hopper on red side");

			sprintf(&buffer[strlen(buffer)],",%d",kHopperBoilerBlue);
			sprintf(key,"thunderdashboard_auto_%d", kHopperBoilerBlue);
			SmartDashboard::PutString(key, "Shoots from hopper on blue side");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearLeftBlueVision);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearLeftBlueVision);
			SmartDashboard::PutString(key, "Vision - Left side gear");

			sprintf(&buffer[strlen(buffer)],",%d",kSideGearRightBlueVision);
			sprintf(key,"thunderdashboard_auto_%d", kSideGearRightBlueVision);
			SmartDashboard::PutString(key, "Vision - Right side gear");

			SmartDashboard::PutString("thunderdashboard_auto_list", buffer);
	}
	void Autonomoose::Process()
	{
/*	char cmd [80];
		float p1 = 0;
		float p2 = 0;
		char file [80];
		FILE *fileThing;
		sprintf(file, "auto%i.txt", Mode);
		fileThing = fopen("auto.txt", "r");
		fclose(fileThing);
		do{
			fscanf(fileThing, "%s %e %e", cmd, &p1, &p2);
			printf("%s %e %e", cmd, p1, p2);
			if(strcmp(cmd, "drive") == 0){
				_drive->Auto_Straight(p1,p2);
				printf("drive \n");
			}
			if(strcmp(cmd, "turn") == 0){
				_drive->Auto_Pivot_Turn(p1);
				printf("turn \n");
			}
			if(strcmp(cmd, "gear") == 0){
				if(p1 == 1){
					_gear->Extend_Flippers();
					printf("gear \n");
				}
			}
			if(strcmp(cmd, "preheat") == 0){
				if(p1 == 1){
					_fuelSystem->SetAction(FuelSystem::PREHEAT);
					printf("preheat \n");
				}
			}
			if(strcmp(cmd, "shoot") == 0){
				if(p1 == 1){
					_fuelSystem->SetAction(FuelSystem::SHOOT);
					printf("shoot \n");
				}
			}
			if(strcmp(cmd, "intake") == 0){
				if(p1 == 1){
					_fuelSystem->SetAction(FuelSystem::INTAKE);
					printf("drive \n");
				}
			}

		}
		while(!feof(fileThing));*/
		switch (Mode){
			case kAutoNothing:
				Auto_Nothing();
				break;
			case kCrossBaseLine:
				Cross_Base_Line();
				break;
			case kHighBoilerRed:
				High_Boiler_Red();
				break;
			case kHightBoilerBlue:
				High_Boiler_Blue();
				break;
			case kCenterGear:
				Center_Gear();
				break;
			case kHighBoilerBaselineBlue:
				High_Boiler_Baseline_Blue();
				break;
			case kHighBoilerBaselineRed:
				High_Boiler_Baseline_Red();
				break;
			case kSideGearLeftBlue:
				Side_Gear_Left_Blue();
				break;
			case kSideGearLeftBlueVision:
				Side_Gear_Left_BlueVision();
				break;
			case kSideGearRightBlueVision:
				Side_Gear_Right_BlueVision();
				break;
			case kSideGearRightBlue:
				Side_Gear_Right_Blue();
				break;
			case kSideGearLeftRed:
				Side_Gear_Left_Red();
				break;
			case kSideGearRightRed:
				Side_Gear_Right_Red();
				break;
			case kGearBoilerBlue:
				Gear_Boiler_Blue();
				break;
			case kGearBoilerRed:
				Gear_Boiler_Red();
				break;
			case kOtherHopperBaselineBlue:
				Other_Hopper_Baseline(true);
				break;
			case kOtherHopperBaselineRed:
				Other_Hopper_Baseline(false);
				break;
			case kHopperBoilerRed:
				Hopper_Shoot(false);
				break;
			case kHopperBoilerBlue:
				Hopper_Shoot(true);
				break;

		}
	}

	void Autonomoose::Auto_Nothing(){
			//does nothing... yay!!!
	}

	void Autonomoose::Cross_Base_Line(){
		if (_currentStep == 1){
			_drive->Auto_Straight(.6,125);
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}

		}
	}

	void Autonomoose::High_Boiler_Blue(){
		if(_currentStep ==1 ){
			BoilerStep = 1;
			_currentStep++;
		}
		if(_currentStep == 2){
			Boiler(true);
		}
	}

	void Autonomoose::High_Boiler_Red(){
		if(_currentStep ==1 ){
			BoilerStep =1;
			_currentStep ++;
		}
		if(_currentStep == 2){
			Boiler(false);
		}
	}

	void Autonomoose::Center_Gear(){
		printf("%d \n", _currentStep);
		if(_currentStep == 1){
			_drive->Auto_Straight(.5,90);//40);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 2)
			{
				_currentStep = 4;
			}
		}
		/*if(_currentStep == 3){
			if(_gear->Is_Spike_Engaged() == false){
				_drive->Move_Speed(.3,.3);
			}
			else{
				_drive->Move_Speed(0,0);
				_currentStep++;
			}
		}*/
		if(_currentStep == 4){
			_drive->Auto_Straight(.3,10);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 5){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > .25){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 6){
			_gear->Extend_Flippers();
			if(_timer.Get() > 1){
			_currentStep++;
			}

		}
		if(_currentStep == 7){
			_drive->Auto_Straight(-.25,20);
			_currentStep++;
		}
		if(_currentStep == 8){
			if(_drive->Is_Auto_Straight_Finished() == true)
			{
				_currentStep++;
			}
		}
		if(_currentStep == 9){
			_gear->Retract_Flippers();
			_currentStep++;
		}

	}

	void Autonomoose::High_Boiler_Baseline_Blue(){
		if(_currentStep == 1){
			BoilerStep = 1;
			_currentStep++;
		}
		if(_currentStep == 2){
			Boiler(true);
		}
		if(_currentStep == 3){
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_timer.Get() >= kTimeForShoot){
				_shooter->End_Shoot();
				_bucket->Stop_Enqueue();
				_bucket->Indexer_Set_Direction(Bucket::STOP);
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(-.5,20);
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 7){
			_drive->Auto_Pivot_Turn(-60);
			_currentStep++;
		}
		if(_currentStep == 8){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 9){
			_drive->Auto_Straight(-.7,100);
			_currentStep++;
		}
		if(_currentStep == 10){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
	}

	void Autonomoose::High_Boiler_Baseline_Red(){
		if(_currentStep ==1){
			BoilerStep = 1;
			_currentStep++;
		}
		if(_currentStep == 2){
			Boiler(false);
		}
		if(_currentStep == 3){
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_timer.Get() >= kTimeForShoot){
				_shooter->End_Shoot();
				_bucket->Stop_Enqueue();
				_bucket->Indexer_Set_Direction(Bucket::STOP);
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(-.5,20);
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 7){
			_drive->Auto_Pivot_Turn(35);
			_currentStep++;
		}
		if(_currentStep == 8){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 9){
			_drive->Auto_Straight(-.6,100);				//possible value change
			_currentStep++;
		}
		if(_currentStep == 10){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
	}

	void Autonomoose::Side_Gear_Right_Red(){
		if(_currentStep == 1){
			_drive->Auto_Straight(.6,70);//30);
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
#ifndef VISIONTRACKING
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(-60);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(.4,30);//35);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.9){
				_currentStep = 8;
			}
		}
	/*	if(_currentStep == 7){
			if(!_gear->Is_Spike_Engaged()){
				_drive->Move_Speed(.15,.15);
			}
			else{
				_drive->Move_Speed(0,0);
				_currentStep++;
			}
		}*/
#else
		if(_currentStep == 3){
			_drive->Auto_Vision_Turn(true);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Vision_Straight();//35);
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep = 8;
			}
		}
#endif
		if(_currentStep == 8){
			_drive->Auto_Straight(.25,4.3);//6);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 9){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > .25){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 10){
			_gear->Extend_Flippers();
			_currentStep++;
		}
		if(_currentStep == 11){
			if(_timer.Get() > .5)
			_currentStep++;
		}
		if(_currentStep == 12){
			_drive->Auto_Straight(-.3,20);
			_currentStep++;
			}
		if(_currentStep == 13){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 14){
			_gear->Retract_Flippers();
			_currentStep++;
		}
	}

	void Autonomoose::Side_Gear_Left_Red(){
		if(_currentStep == 1){
			_drive->Auto_Straight(.6,70);//30);
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
#ifndef VISIONTRACKING
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(76.5);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(.35,95);//35);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.9){
				_currentStep = 8;
			}
		}
#else
		if(_currentStep == 3){
			_drive->Auto_Vision_Turn(false);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Vision_Straight();//35);
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep = 8;
			}
		}
#endif
	/*	if(_currentStep == 7){
			if(!_gear->Is_Spike_Engaged()){
				_drive->Move_Speed(.15,.15);
			}
			else{
				_drive->Move_Speed(0,0);
				_currentStep++;
			}
		}*/
		if(_currentStep == 8){
			_drive->Auto_Straight(.25,2.25);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 9){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > .25){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 10){
			_gear->Extend_Flippers();
			_currentStep++;
		}
		if(_currentStep == 11){
			if(_timer.Get() > .5)
			_currentStep++;
		}
		if(_currentStep == 12){
			_drive->Auto_Straight(-.4,20);
			_currentStep++;
		}
		if(_currentStep == 13){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 14){
			_gear->Retract_Flippers();
			_currentStep++;
		}
	}

	void Autonomoose::Side_Gear_Right_Blue(){	//ONLY WORKS ON BLUE SIDE MAYBE!!!!!!!!!
		if(_currentStep == 1){
			_drive->Auto_Straight(.6,70);//30);
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
#ifndef VISIONTRACKING
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(-70);//70);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(.35,95);//35);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.9){
				_currentStep = 11;
			}
		}
		/*	if(_currentStep == 7){
				if(!_gear->Is_Spike_Engaged()){
					_drive->Move_Speed(.15,.15);
				}
			else{
				_drive->Move_Speed(0,0);
					_currentStep++;
				}
			}*/
#else
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(-70);//70);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 5){
			_drive->Auto_Vision_Turn(true);
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 7){
			_drive->Auto_Straight(.35,95);//35);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 8){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.9){
				_currentStep++;
			}
		}
		if(_currentStep == 9){
			_drive->Auto_Vision_Straight();//35);
			_currentStep++;
		}
		if(_currentStep == 10){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep = 8;
			}
		}
#endif
		if(_currentStep == 11){
			_drive->Auto_Straight(.25,30);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 12){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() >.25){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 13){
			_gear->Extend_Flippers();
			_currentStep++;
		}
		if(_currentStep == 14){
			if(_timer.Get() > .5)
				_currentStep++;
		}
		if(_currentStep == 15){
			_drive->Auto_Straight(-.4,20);//12);
			_currentStep++;
		}
		if(_currentStep == 16){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 17){
			_gear->Retract_Flippers();
			_currentStep++;
		}
	}

	void Autonomoose::Side_Gear_Left_Blue(){			//ONLY WORK ON BLUE SIDE MAYBE
			if(_currentStep == 1){
				_drive->Auto_Straight(.6,70);//30);
				_currentStep++;
			}
			if(_currentStep == 2){
				if(_drive->Is_Auto_Straight_Finished() == true){
					_currentStep++;
				}
			}
			if(_currentStep == 3){
				_drive->Auto_Pivot_Turn(68);//70);
				_currentStep++;
			}
			if(_currentStep == 4){
				if(_drive->Is_Auto_Turn_Finished() == true){
					_currentStep++;
				}
			}
			if(_currentStep == 5){
				_drive->Auto_Straight(.4,90);//35);
				_timer.Reset();
				_currentStep++;
			}
			if(_currentStep == 6){
				if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.9){
					_currentStep = 8;
				}
			}
		/*	if(_currentStep == 7){
				if(!_gear->Is_Spike_Engaged()){
					_drive->Move_Speed(.15,.15);
				}
				else{
					_drive->Move_Speed(0,0);
					_currentStep++;
				}
			}*/
			if(_currentStep == 8){
				_drive->Auto_Straight(.25,4.3);//6);
				_timer.Reset();
				_currentStep++;
			}
			if(_currentStep == 9){
				if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > .25){
					_timer.Reset();
					_currentStep++;
				}
			}
			if(_currentStep == 10){
				_gear->Extend_Flippers();
				_currentStep++;
			}
			if(_currentStep == 11){
				if(_timer.Get() > .5)
				_currentStep++;
			}
			if(_currentStep == 12){
				_drive->Auto_Straight(-.3,20);//20);
				_currentStep++;
			}
			if(_currentStep == 13){
				if(_drive->Is_Auto_Straight_Finished() == true){
					_currentStep++;
				}
			}
			if(_currentStep == 14){
				_gear->Retract_Flippers();
				_currentStep++;
			}
		}

#define VISION_TESTING
	void Autonomoose::Side_Gear_Left_BlueVision(){			//ONLY WORK ON BLUE SIDE MAYBE
		if(_currentStep == 1){
			_drive->Auto_Straight(.62,52); 	// 52 for left blue
			_currentStep++;

		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(45);//70);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep = 11;
				printf("turnfinished %d\n", _currentStep);
			}
		}
		if(_currentStep == 11){
			_drive->Auto_Vision_Straight();//35);
			printf("visionstraightrunning %d\n", _currentStep);
			_currentStep++;
		}
		if(_currentStep == 12){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
				printf("vision straight STOPPED %d\n", _currentStep);
			}
			if(_drive->Did_Auto_Die()){
				_currentStep = 99;
				printf("RIP AUTO\n");
			}
		}
		if(_currentStep == 13){
			_drive->Auto_Vision_Turn(false);
			_currentStep++;
		}
		if(_currentStep == 14){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
			if(_drive->Did_Auto_Die()){
				_currentStep = 99;
				printf("RIP AUTO\n");
			}
		}
		if(_currentStep == 15){
			_drive->Auto_Straight(.35,35);//6);
			//_drive->Move_Speed(.36,.34);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 16){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 2.2){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 17){
			_gear->Extend_Flippers();
			_currentStep++;
		}
		if(_currentStep == 18){
			if(_timer.Get() > .5)
			_currentStep++;
		}
		if(_currentStep == 19){
			_drive->Auto_Straight(-.23,20);//20);
			_currentStep++;
		}
		if(_currentStep == 20){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 21){
			_gear->Retract_Flippers();
			_currentStep++;
		}
	}
	void Autonomoose::Side_Gear_Right_BlueVision(){			//ONLY WORK ON BLUE SIDE MAYBE
		if(_currentStep == 1){
			_drive->Auto_Straight(.62,52); 	// 52 for left blue
			_currentStep++;

		}
		if(_currentStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 3){
			_drive->Auto_Pivot_Turn(-45);//70);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep = 11;
				printf("turnfinished %d\n", _currentStep);
			}
		}
		if(_currentStep == 11){
			_drive->Auto_Vision_Straight();//35);
			printf("visionstraightrunning %d\n", _currentStep);
			_currentStep++;
		}
		if(_currentStep == 12){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
				printf("vision straight STOPPED %d\n", _currentStep);
			}
			if(_drive->Did_Auto_Die()){
				_currentStep = 99;
				printf("RIP AUTO\n");
			}
		}
		if(_currentStep == 13){
			_drive->Auto_Vision_Turn(false);
			_currentStep++;
		}
		if(_currentStep == 14){
			if(_drive->Is_Auto_Turn_Finished() == true){
				_currentStep++;
			}
			if(_drive->Did_Auto_Die()){
				_currentStep = 99;
				printf("RIP AUTO\n");
			}
		}
		if(_currentStep == 15){
			_drive->Auto_Straight(.35,35);//6);
			//_drive->Move_Speed(.36,.34);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 16){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 2.2){
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 17){
			_gear->Extend_Flippers();
			_currentStep++;
		}
		if(_currentStep == 18){
			if(_timer.Get() > .5)
			_currentStep++;
		}
		if(_currentStep == 19){
			_drive->Auto_Straight(-.23,20);//20);
			_currentStep++;
		}
		if(_currentStep == 20){
			if(_drive->Is_Auto_Straight_Finished() == true){
				_currentStep++;
			}
		}
		if(_currentStep == 21){
			_gear->Retract_Flippers();
			_currentStep++;
		}
	}

	void Autonomoose::Gear_Boiler_Blue(){
		int step = 1;
		if(step == 1){
			Side_Gear_Right_Red();
			step++;
		if(_currentStep == 15){
			_drive->Auto_Straight(-.3,10);
			_currentStep++;
		}
		if(_currentStep == 16){
			if(_drive->Is_Auto_Straight_Finished())
				_currentStep++;
		}
		if(_currentStep == 17){
			_drive->Auto_Pivot_Turn(-165);
		}
		if(_currentStep == 18){
			if(_drive->Is_Auto_Turn_Finished())
				_currentStep++;
		}
		if(_currentStep == 19){
			_drive->Auto_Straight(.6,100);
			_currentStep++;
		}
		if(_currentStep == 20){
			if(_drive->Is_Auto_Straight_Finished())
				_currentStep++;
		}
		if(_currentStep == 21){
			_drive->Auto_Straight(.3,10);
			_timer.Reset();
			_fuelSystem->SetAction(FuelSystem::PREHEAT);
		}
		if(_currentStep == 22){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 1.5){
				_currentStep++;
			}
		}
		if(_currentStep == 23){
			_fuelSystem->SetAction(FuelSystem::SHOOT);
		}
	}
	}

	void Autonomoose::Gear_Boiler_Red(){
		int step = 1;
		if(step == 1){
			Side_Gear_Right_Red();
			step++;
		}
		if(_currentStep == 15){
			_drive->Auto_Straight(-.25,10);
			_currentStep++;
		}
		if(_currentStep == 16){
			if(_drive->Is_Auto_Straight_Finished())
				_currentStep++;
		}
		if(_currentStep == 17){
			_drive->Auto_Pivot_Turn(205);
			_currentStep++;
		}
		if(_currentStep == 18){
			if(_drive->Is_Auto_Turn_Finished())
				_currentStep++;
		}
		if(_currentStep == 19){
			_drive->Auto_Straight(.5,100);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 20){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 3)
				_currentStep++;
		}
		if(_currentStep == 21){
			_drive->Auto_Straight(.3,10);
			_timer.Reset();
			_fuelSystem->SetAction(FuelSystem::PREHEAT);
			_currentStep++;
		}
		if(_currentStep == 22){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 1){
				_currentStep++;
			}
		}
		if(_currentStep == 23){
			_fuelSystem->SetAction(FuelSystem::SHOOT);
		}
	}

	void Autonomoose::Other_Hopper_Baseline(bool blue){
		if(_currentStep == 1){
			_timer.Reset();
		//	_shooter->_autoShoot = true;
			_fuelSystem->SetAction(FuelSystem::PREHEAT);
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_timer.Get()>1.5){
				_fuelSystem->SetAction(FuelSystem::SHOOT);
				_timer.Reset();
				_currentStep++;
			}
		}
		if(_currentStep == 3){
			if(_timer.Get()>7){
			//_shooter->_autoShoot = false;
			_currentStep++;
			}
		}
		if(_currentStep == 4){
			if(blue == true)
				_drive->Auto_Pivot_Turn(80);
			else
				_drive->Auto_Pivot_Turn(-80);
			_currentStep++;
		}
		if(_currentStep == 5){
			if(_drive->Is_Auto_Turn_Finished())
				_currentStep++;
		}
		if(_currentStep == 6){
			_drive->Auto_Straight(.4,100);
		}
		if(_currentStep == 7){
			if(_drive->Is_Auto_Straight_Finished()){
				_currentStep++;
			}
		}
	}

	void Autonomoose::Hopper_Shoot(bool blue){
		if(_currentStep == 1){
			//_drive->Auto_Straight(-.6,190);
			_drive->Move_Speed(-.5,-.53);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 2){
			if(_timer.Get() > 3.15)//_drive->Is_Auto_Straight_Finished())
				_currentStep++;
		}
		if(_currentStep == 3){
			if(blue)
				_drive->Auto_Pivot_Turn(90);
			else
				_drive->Auto_Pivot_Turn(-38);
			_currentStep++;
		}
		if(_currentStep == 4){
			if(_drive->Is_Auto_Turn_Finished())
				_currentStep++;
		}
		if(_currentStep == 5){
			_drive->Auto_Straight(.45,84);
			_timer.Reset();
			_currentStep++;
		}
		if(_currentStep == 6){
			if(_drive->Is_Auto_Straight_Finished() || _timer.Get() > 1.45)
				_currentStep++;
		}
		if(_currentStep == 7){
			if(blue)
				_drive->Auto_Pivot_Turn(-90);
			else
				_drive->Auto_Pivot_Turn(21.5);
			_currentStep++;
		}
		if(_currentStep == 8){
			if(_drive->Is_Auto_Turn_Finished())
				_currentStep++;
		}
		if(_currentStep == 9){
			_drive->Auto_Straight(.4,25);
			_currentStep++;
		}
		if(_currentStep == 10){
			if(_drive->Is_Auto_Straight_Finished()){
				_currentStep++;
			}
		}
		if(_currentStep == 11){
			if(blue)
				_drive->Auto_Pivot_Turn(20);
			else
				_drive->Auto_Pivot_Turn(37);
			_currentStep++;
		}
		if(_currentStep == 12){
			if(_drive->Is_Auto_Turn_Finished()){
				if(blue)
					_drive->Auto_Pivot_Turn(-10);
				else
					_drive->Auto_Pivot_Turn(-37);
				_currentStep++;
			}
		}
		if(_currentStep == 13){
			if(_drive->Is_Auto_Turn_Finished()){
				_drive->Auto_Straight(.6,10);
				_timer.Reset();
			//	_fuelSystem->SetAction(_fuelSystem->INTAKE_PREHEAT);
				_currentStep++;
			}
		}
		if(_currentStep == 14){
			if(_timer.Get()>.75){
			//	_fuelSystem->SetAction(_fuelSystem->SHOOT);
				_currentStep++;
			}
		}

	}
	void Autonomoose::Boiler(bool turnBlue){
		printf("%d \n", BoilerStep);
		if (BoilerStep == 1){
			_drive->Auto_Straight(.5,40);
			BoilerStep++;
		}
		if(BoilerStep == 2){
			if(_drive->Is_Auto_Straight_Finished() == true){
				BoilerStep++;
			}
		}
		if(BoilerStep == 3){
			if(turnBlue)
				_drive->Auto_Pivot_Turn(-90);
			else
				_drive->Auto_Pivot_Turn(90);
			BoilerStep++;
		}
		if(BoilerStep == 4){
			if(_drive->Is_Auto_Turn_Finished())
			BoilerStep++;
		}
		if(BoilerStep == 5){
			_drive->Auto_Straight(.4, 40);
			_timer.Reset();
			_fuelSystem->SetAction(FuelSystem::PREHEAT);
				BoilerStep++;
		}
		if(BoilerStep == 6){
			if(_drive->Is_Auto_Straight_Finished() == true || _timer.Get() > 1.25){
				_timer.Reset();
				BoilerStep++;
			}
		}
		if(BoilerStep == 7){
			_fuelSystem->SetAction(FuelSystem::SHOOT);
			BoilerStep++;
			_currentStep++;
			}
		}

	void Autonomoose::Debug(Feedback *feedback)
	{
		feedback->send_Debug_Double("autonomoose","current Step", _currentStep);
		switch (Mode){
					case kAutoNothing:
						feedback->send_Debug_String("autonomoose", "auto mode", "do nothing");
						break;
					case kCrossBaseLine:
						feedback->send_Debug_String("autonomoose", "auto mode", "cross baseline");
						break;
					case kHighBoilerRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "high boiler red");
						break;
					case kHightBoilerBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "high boiler blue");
						break;
					case kCenterGear:
						feedback->send_Debug_String("autonomoose", "auto mode", "Center gear");
						break;
					case kHighBoilerBaselineBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "High boiler baseline blue");
						break;
					case kHighBoilerBaselineRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "High boiler baseline red");
						break;
					case kSideGearLeftBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "Side gear blue left");
						break;
					case kSideGearRightBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "Side gear blue right");
						break;
					case kSideGearRightRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "Side gear red right");
						break;
					case kSideGearLeftRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "Side gear red left");
						break;
					case kGearBoilerBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "Boiler gear blue");
						break;
					case kGearBoilerRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "Boiler gear red");
						break;
					case kHopperBoilerRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "Hopper boiler blue");
						break;
					case kHopperBoilerBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "Hopper boiler red");
						break;
					case kOtherHopperBaselineBlue:
						feedback->send_Debug_String("autonomoose", "auto mode", "Robot hopper baseline blue");
						break;
					case kOtherHopperBaselineRed:
						feedback->send_Debug_String("autonomoose", "auto mode", "Robot hopper baseline red");
						break;
					case kSideGearLeftBlueVision:
						feedback->send_Debug_String("autonomoose", "auto mode", "Side gear blue left vision");
						break;
		}
	}

	void Autonomoose::Reset(){
		_currentStep = 1;
		Mode = kAutoNothing;

	}

