#ifndef AUTONOMOOSE_H_
#define AUTONOMOOSE_H_

#include "Feedback.h"
#include "IOMap.h"
#include "Drive.h"
#include "Intake.h"
#include "Bucket.h"
#include "Gear.h"
#include "Shooter.h"
#include "FuelSystem.h"
#include "stdio.h"

class Autonomoose{

public:
	typedef enum {
			kAutoNothing,
			kCrossBaseLine,
			kHighBoilerRed,
			kHightBoilerBlue,
			kCenterGear,
			kHighBoilerBaselineRed,
			kHighBoilerBaselineBlue,
			kSideGearRightBlue,
			kSideGearLeftBlue,
			kSideGearRightRed,
			kSideGearLeftRed,
			kGearBoilerBlue,
			kGearBoilerRed,
			kOtherHopperBaselineBlue,
			kOtherHopperBaselineRed,
			kHopperBoilerRed,
			kHopperBoilerBlue,
			kSideGearLeftBlueVision,
			kSideGearRightBlueVision
		}AutoMode;
	Autonomoose(Drive *drive, Intake *intake, Bucket *bucket, Gear *gear, Shooter *shooter, FuelSystem *fuelSystem);

	void Set_Auto_Mode(AutoMode Mode);

	void Process();

	void Auto_Nothing();

	void Cross_Base_Line();

	void High_Boiler_Blue();

	void High_Boiler_Red();

	void Center_Gear();

	void Side_Gear_Right_Blue();

	void Side_Gear_Left_Blue();

	void Side_Gear_Left_BlueVision();

	void Side_Gear_Right_BlueVision();

	void Side_Gear_Right_Red();

	void Side_Gear_Left_Red();

	void High_Boiler_Baseline_Blue();

	void High_Boiler_Baseline_Red();

	void Gear_Boiler_Blue();

	void Gear_Boiler_Red();

	void Hopper_Shoot(bool blue);

	void Other_Hopper_Baseline(bool blue);

	void Shoot_From_Hopper(bool blue);

	void Boiler(bool turnBlue);

	void Debug(Feedback *feedback);

	void AutoDashboardSend();

	void Reset();



	AutoMode Mode;

private:

	int _currentStep;

	Drive *_drive;
	Intake *_intake;
	Bucket *_bucket;
	Gear *_gear;
	Shooter *_shooter;
	Timer _timer;
	FuelSystem *_fuelSystem;

	int BoilerStep;

};

#endif
