#ifndef BUCKET_H_
#define BUCKET_H_

#include "WPILib.h"
#include "Feedback.h"
#include "CANTalon.h"
class Bucket{
public:

	typedef enum {FORWARD, BACKWARD, OFF} ConveyorDirection;

	typedef enum {IN, OUT, STOP} BeaterDirection;

	Bucket();


	void Start_Enqueue(ConveyorDirection direction);

	void Stop_Enqueue();


	/*
	 * This Function will accept IN, OUT, Or STOP
	 * It will be completely overidden by start Enqueue Function, this functio will only work after Stop Enqueue
	 */
	void Beating_Bar_Set_Direction(BeaterDirection bdirection);

	void Debug(Feedback *feedback);

	void Set_Sensor_Broken(bool Broken);

	void Process();

	void Reset();

	void Init_Dashboard_Values(Feedback *feedback);
	void Get_Dashboard_Values(Feedback *feedback);

	void Indexer_Set_Direction(BeaterDirection direction);
private:
	CANTalon conveyor;
	CANTalon beater;
	CANTalon indexer;

	Counter encoder;   // on conveyor
	double _indexerSpeedBlock;
	double _indexerSpeedIndex;
	ConveyorDirection _conveyDirection;
	BeaterDirection _beaterDirection;
	BeaterDirection _indexDirection;
	bool _useSensor;
	double _conveySpeed;
	double _beaterSpeed;

};

#endif
