#ifndef CLIMBING_H_
#define CLIMBING_H_
#define STALLIDXNUM 20

#include "Feedback.h"
#include "CANTalon.h"
#include "Bucket.h"
class Climbing{

public:

	typedef enum {IN, OUT, STOP} ClimbingDirection;

	Climbing();

	void Climb_Direction(ClimbingDirection direction, double speed);

	void Deploy();

	bool Is_Climb_Complete();

	void Process();

	void Reset();

	void Debug(Feedback *feedback);

	void Get_Dashboard_Values(Feedback *feedback);
	void Init_Dashboard_Values(Feedback *feedback);
	bool _climbFinished;

private:
	CANTalon MotorA;
	CANTalon MotorB;
	ClimbingDirection Direction;
	Servo DeployServo;

	float _currentValues[STALLIDXNUM];
	int _stallIdx;
	double _servoPos;
	double _climberSpeed;
	double _stopCurrent;
};

#endif
