#define brokensNoWork

#include "Drive.h"
#include "Gear.h"
#include "FuelSystem.h"
#ifndef CONTROLS_H_
#define CONTROLS_H_
#include "WPILib.h"
#include "ControlsButton.h"
#include "Climbing.h"
//Feb 4th
class Controls{

public:

	typedef enum {TELE_OP, AUTO, DISABLED} RobotMode;

	Controls(Drive *drive,  Gear *gear, FuelSystem *fuelsystem, Feedback *feedback, Climbing *climbing);
		~Controls();
	void Process(RobotMode robotmode);

	Timer DashboardTime;

private:

	void ProcessControllerDriver();
	void ProcessControllerAux();
	void ProcessBroken();
	float GetPower(float power, bool slow, bool turbo);
	bool GearRumble();
	void DashboardValues();

	//Pointers
	Drive *_drive;
	Feedback *_feedback;
	Gear *_gear;
	Climbing *_climbing;
	FuelSystem *_fuelsystem;
	/*add the rest*/

	// Joysticks for drivers
	Joystick *_driverJoystick;
	Joystick *_auxJoystick;

#ifdef brokensNoWork
	Joystick *_brokenJoystick;
	ControlsButton *_brokenShooter;
	ControlsButton *_brokenSpikeSensor;
	ControlsButton *_brokenConveyorEncoder;
	ControlsButton *_brokenLeftEncoder;
	ControlsButton *_brokenRightEncoder;
	ControlsButton *_brokenGyro;
#endif

	ControlsButton *_driverSwapDrive;
	ControlsButton *_auxClimb;
	/*
	ControlsButton *_auxShoot;
	ControlsButton *_auxPreHeat;
	ControlsButton *_auxIntake;
	ControlsButton *_auxCloseGear;
	ControlsButton *_auxClimb;
	*/
	bool _swapDrive;
	float GetPosition(Joystick *joystick, int axis, bool fullrange = false);
	float GetPowerTurn(float power, bool slow, bool turbo);
	Timer timer;
	bool _spikeRumble;
};


#endif
