#ifndef FEEDBACK_H_
#define FEEDBACK_H_

#include "ThunderCameraServer.h"

class Feedback{

public:
	Feedback();

	void initCameras();
	void send_Editable_String(const char *subsystem, const char *name, const char *format,...);
	void send_Editable_Double(const char *subsystem, const char *name, double value);
	double get_Editable_Double(const char *subsystem, const char *name, double defaultValue);
	std::string get_Editable_String(const char *subsystem, const char *name, llvm::StringRef defaultValue);
	void send_Debug_String(const char *subsystem, const char *name, const char *format,...);
	void send_Debug_Double(const char *subsystem, const char *name, double value);

	void swapCamera();
	bool isFrontCamera();

	void processCameraSettings();

private:
	ThunderCameraServer *camServer;
	std::vector<std::shared_ptr<nivision::USBCamera> > camVec;
	bool frontCam;
	bool hasBackCam;

	static const int CAM_AUTO = -1;
	int camBrightness;
	int camExposure;
	int camWhiteBalance;

	struct wbSetting {
		char name[64];
		int value;
	};
	struct wbSetting wbSettings[6];
	struct wbSetting *curWbSetting;


};

#endif
