#ifndef FUELSYSTEM_H_
#define FUELSYSTEM_H_

#include "WPILib.h"
#include "Feedback.h"
#include "Bucket.h"
#include "Shooter.h"
#include "Intake.h"

class FuelSystem{
public:
	FuelSystem(Bucket *bucket, Intake *intake, Shooter *shooter);

	// intake, outake, shoot, stop
	//typedef enum {IN, OUT, STOP} IntakeDirection;
	typedef enum {INTAKE, OUTAKE, SHOOT, STOP, INTAKE_PREHEAT, PREHEAT} Action;
	void SetAction (Action action);
	void Process ();
	void Debug(Feedback *feedback);
	void Reset();
	void Set_Bucket_Broken(bool Broken);
	void Set_Intake_Broken(bool Broken);
	void Set_Shooter_Broken(bool Broken);
	void Get_Dashboard_Values(Feedback *feedback);
	void Init_Dashboard_Values(Feedback *feedback);
private:
	Bucket *_bucket;
	Shooter *_shooter;
	Intake *_intake;
	Action _action;
	Timer _pulseTimer;
	bool _pulseIsOn;
	double _pulseOnTime;
	double _pulseOffTime;
};

#endif
