#ifndef GEAR_H_
#define GEAR_H_

#include "WPILib.h"
#include "Feedback.h"
class Gear{
public:
	Gear();



	void Extend_Flippers();
		// Manual extension operation of the flippers.  Cancels any in progress
		// automated deploy operation
	void Retract_Flippers();
		// Manual retract operation of the flippers.  Cancels any in progress
		// automated deploy operation
	bool Is_Deploy_Finished();
		//checks if servos are at their "deployed position"

	void Cancel_Gear_Deploy();
		//closes servo gate in case of accidental deployment

	bool Is_Spike_Engaged();
		//checks sensor if there is a spike present

	bool Is_Gear_Present();
		// checks if gear is present

	void Set_Spike_Sensor_Broken(bool SpikeSensorBroken);

	void Process();

	void Reset();

	void Debug(Feedback *feedback);

	void Get_Dashboard_Values(Feedback *feedback);
	void Init_Dashboard_Values(Feedback *feedback);

private:
	DigitalInput SpikeSensor;

	Servo FlipperAngleL;
	Servo FlipperAngleR;

	bool _spikeSensorBroken;
	bool _retracted;
	double _rFlipperRetract;
	double _lFlipperRetract;
	double _rFlipperExtend;
	double _lFlipperExtend;

};

#endif
