#ifndef SHOOTER_H_
#define SHOOTER_H_

#include "wpilib.h"
#include "Feedback.h"
#include "CANTalon.h"
#include "udplogger.h"

class Shooter{
public:
	Shooter();

	void Start_Shoot();

	void End_Shoot();

	bool Is_Shooter_At_Speed();

	void Process();

	void Debug(Feedback *feedback);

	void Shooter_Set_Broken(bool broken);

	void Reset();

	void Get_Dashboard_Values(Feedback *feedback);
	void Init_Dashboard_Values(Feedback *feedback);
	bool _lastAutoShoot;
	bool _autoShoot;


private:
	CANTalon shooterMotor1;
	CANTalon shooterMotor2;
	bool _shooting;
	double _shootSpeed;
	bool _broken;
	bool _lastBroken;
	double _brokenSpeed;
	double _pVal;
	double _iVal;
	double _dVal;
	double _fVal;
	bool _shootingLast;
	Timer timer;
	double _desiredRPS;
	double _desiredRPM;
	double _goingUp;

	UDPLogger *logger;
	Timer loggerTimer;

};

#endif
