#ifndef UDPLOGGER_H
#define UDPLOGGER_H
#include "PIDController.h"
#include "PIDOutput.h"
#include <netinet/in.h>

#define SUPPRESS_ERRORS 1

class UDPLogger {
public:
	UDPLogger(bool stdoutprint = false);
	~UDPLogger();

	void init(const char *ip, int port);
	void log(const char *fmt, ...);
	void setEnabled(bool en);
private:
#define UDPLOGGER_BUFSIZE 65536
	char buf[UDPLOGGER_BUFSIZE];
	int fd;
	bool stdoutprint;
	bool enabled;
	struct sockaddr_in saddr;
};

#endif
